*************************************************************************
** PROCEDIMIENTO PARA ASIGNAR UN CURSO A UN TRABAJADOR
*************************************************************************
PROCEDURE asig_curso_tra

USE plantill NEW
    INDEX ON cve_per TO indplant
USE nombres INDEX indnombr NEW
USE catprin INDEX indprin NEW
DO WHILE .T.
   clave_trab=pideclave_trab()
   IF LASTKEY()=27
      CLOSE ALL
      RETURN
   ELSE
      barstatus(4) 
      clave_puesto=busca_cursos(clave_trab)
      USE pues_tmp NEW
      INDEX ON cve_esp + cve_per TO indpuetm
      USE curs_tmp NEW
      INDEX ON cve_esp + cve_per TO indtestm
      JOIN WITH pues_tmp TO cursapli FOR pues_tmp->cve_esp = curs_tmp->cve_esp;
        FIELDS cve_per,cve_esp
      USE cursapli NEW
      INDEX ON cve_per TO indcurso UNIQUE
      SET RELATION TO cve_per INTO catprin
      DO WHILE .T.
         limpiamenu(8,5,22,79)
         clave_curso_gral=desp_curgral(2,2,12,55)
         IF clave_curso_gral= NIL
            limpiamenu(1,1,14,58)
            EXIT
         ELSE
            USE p_curso NEW
            USE trabcurs NEW
            secuencia=desp_curprog(5,5,15,58,clave_curso_gral)            
            LOCATE FOR cve_curso = clave_curso_gral .AND. sec = secuencia
            IF num_part = num_max
               ponerror("Cupo del curso agotado")               
               limpiamenu(1,1,17,60)
               CLOSE trabcurs
               CLOSE p_curso
               EXIT
            ELSE
               SELECT trabcurs
               LOCATE FOR cve_per=clave_trab .AND. cve_curso = clave_curso_gral
               IF FOUND()
                  ponerror("Trabajador inscrito en curso")
                  limpiamenu(1,1,17,60)
                  CLOSE trabcurs
                  CLOSE p_curso
                  EXIT
               ELSE
                  resp=dialogo("Es correcta la asignacin? S/N ")
                  IF resp="S"
                     SELECT trabcurs
                     APPEND BLANK
                     REPLACE cve_per WITH clave_trab
                     REPLACE cve_curso WITH clave_curso_gral
                     REPLACE sec WITH secuencia
                     SELECT p_curso
                     LOCATE FOR cve_curso = clave_curso_gral .AND. sec = secuencia
                     REPLACE num_part WITH num_part + 1
                     limpiamenu(1,1,23,79)
                     CLOSE trabcurs
                     CLOSE p_curso
                     EXIT
                  ENDIF
               ENDIF
            ENDIF
         ENDIF
      ENDDO
   ENDIF
ENDDO

*************************************************************************
** FUNCION QUE SOLICITA LA CLAVE DEL TRABAJADOR PARA ASIGNARLO A UN CURSO
*************************************************************************
FUNCTION pideclave_trab

DO WHILE .T.
   barstatus(7)
   clave = SPACE(8)
   SET COLOR TO W/BG+,B+/W
   STORE SPACE(8) TO clave
   marcmenu(8,15,15,65)
   SET COLOR TO W/BG+,B+/W
   SETKEY(-1,{||cat_gral(6,3,20,56,"nombres","W")})
   @9,25 SAY "Introduzca la clave del trabajador:"   
   @11,35 GET clave VALID .NOT. clave= " "
   READ
   IF LASTKEY()=27
      RETURN
   ELSE
      SELECT nombres
      GO TOP
      SEEK clave
      IF FOUND()
         trab=TRIM(nombre_s)+" "+TRIM(paterno)+" "+TRIM(materno)
         @13,25 SAY trab
         resp=dialogo("Trabajador correcto? S/N ")
         IF resp="S"
            RETURN(clave)
         ELSE
            limpiamenu(17,30,21,79)
         ENDIF
      ELSE
         ponerror("Clave inexistente")
      END
   ENDIF
ENDDO


*************************************************************************
** FUNCION QUE BUSCA LOS CURSOS QUE PUEDE TOMAR UN TRABAJADOR
*************************************************************************
FUNCTION busca_cursos(cve_trabaja)

USE asig_esp NEW              
SELECT plantill
SEEK cve_trabaja
vcve_puest=cve_puest
SELECT asig_esp
SET FILTER TO
SET FILTER TO cve_per = vcve_puest
COPY TO pues_tmp ALL
SET FILTER TO
SET FILTER TO tipo="C"
COPY TO curs_tmp ALL 
CLOSE asig_esp        
RETURN (vcve_puest)

*************************************************************************
** FUNCION QUE DESPLIEGA LOS CURSOS APLICABLES A UN PUESTO
*************************************************************************
FUNCTION desp_curgral(y1,x1,y2,x2)

tottest=0
DECLARE campos[2]
PRIVATE clave
SELECT cursapli
SET COLOR TO W+/BG+,B+/W
GO TOP
campos[1]="cve_per"
campos[2]="catprin->nom_obj"
tottest=LASTREC()
IF tottest>=1 
   marcmenu(y1-1,x1-1,y2+1,x2+1,"W+/BG+","B+/W")
   DBEDIT(y1,x1,y2,x2,campos,"FUN_ED3",;
     {"XXXXXXXX","XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"},;
     {"CLAVE","NOMBRE"},"","  ","","")
   SET COLOR TO W+/BG+,B+/W
   IF (LASTKEY()=13)
      clave=&campo_sel
   ENDIF
ELSE
   ponerror("El puesto no requiere cursos")
ENDIF
CLOSE pues_tmp
CLOSE curs_tmp
CLOSE cursapli
RETURN(clave)

*************************************************************************
** FUNCION QUE DESPLIEGA LOS CURSOS PROGRAMADOS
*************************************************************************
FUNCTION desp_curprog(y1,x1,y2,x2,clave_curso_gral)

tottest=0
DECLARE campos[4]
PRIVATE clave
SELECT p_curso
SET COLOR TO W+/BG+,B+/W
campos[1]="sec"
campos[2]="fecha_ini"
campos[3]="fecha_fin"
campos[4]="horario"
tottest=LASTREC()
IF tottest >= 1 
   marcmenu(y1-1,x1-1,y2+1,x2+1,"W+/BG+","B+/W")
   SET FILTER to cve_curso = clave_curso_gral
   GO TOP
   DBEDIT(y1,x1,y2,x2,campos,"FUN_ED3",;
     {"999","99/99/99","99/99/99","99:99-99:99"},;
     {"NCURSO","FECHA INICIO","FECHA TERMINO","HORARIO"},"","  ","","")
   SET COLOR TO W+/BG+,B+/W
   IF (LASTKEY()=13)
      clave=&campo_sel
   ENDIF
ELSE
   ponerror("El puesto no requiere cursos")
ENDIF
SET FILTER TO
RETURN(clave)

*************************************************************************
** PROCEDIMIENTO PARA BORRAR UN CURSO A UN TRABAJADOR
*************************************************************************
PROCEDURE borra_curso_tra

USE plantill NEW
    INDEX ON cve_per TO indplant
USE nombres INDEX indnombr NEW
USE catprin INDEX indprin NEW
DO WHILE .T.
   totcurs = 0
   clave_trab=pideclave_trab()
   IF LASTKEY()=27
      CLOSE ALL
      RETURN
   ELSE
      USE p_curso NEW
          INDEX ON cve_curso TO indpcur
      USE trabcurs NEW
          INDEX ON cve_per + cve_curso TO indtracu
      SET RELATION TO cve_curso INTO p_curso, cve_curso INTO catprin
      SET FILTER TO cve_per = clave_trab
      COUNT FOR cve_per = clave_trab TO totcurs
      IF totcurs >= 1 
         clave_cur = desp_curtra(5,5,15,58,clave_trab)
      ELSE
         ponerror("Trabajador sin cursos registrados")
         clave_cur = NIL
      ENDIF
      IF clave_cur = NIL
         limpiamenu(1,1,22,79)
      ELSE
         resp=dialogo("Desea eliminar este curso? S/N ")
         IF resp="S"
            SELECT trabcurs
            SEEK clave_trab + clave_cur
            DELETE             
            PACK
         ENDIF
      ENDIF
      limpiamenu(1,1,22,79)
   ENDIF   
   CLOSE p_curso
   CLOSE trabcurs
ENDDO

*************************************************************************
** PROCEDIMIENTO PARA ASIGNAR LA EVALUACION DE UN CURSO A UN TRABAJADOR
*************************************************************************
PROCEDURE eval_curso_tra(tipo)

USE plantill NEW
    INDEX ON cve_per TO indplant
USE nombres INDEX indnombr NEW
USE catprin INDEX indprin NEW
DO WHILE .T.
   totcurs = 0
   eval_curso = 0
   clave_trab=pideclave_trab()
   IF LASTKEY()=27
      CLOSE ALL
      RETURN
   ELSE
      USE p_curso NEW
          INDEX ON cve_curso TO indpcur
      USE trabcurs NEW
          INDEX ON cve_per + cve_curso TO indtracu
      SET RELATION TO cve_curso INTO p_curso, cve_curso INTO catprin
      SET FILTER TO cve_per = clave_trab
      COUNT FOR cve_per = clave_trab TO totcurs
      IF totcurs >= 1 
         clave_cur = desp_curtra(5,5,15,58,clave_trab)
      ELSE
         ponerror("Trabajador sin cursos registrados")
         clave_cur = NIL
      ENDIF
      IF clave_cur = NIL
         limpiamenu(1,1,22,79)
      ELSE
         resp = "N"
         DO WHILE resp="N"
            SELECT trabcurs
            IF tipo = "A" 
               @20,2 SAY "Evaluacin curso: " GET eval_curso PICTURE "99.99"
            ELSE
               SEEK cve_per + cve_curso            
               eval_curso = calif_trab
               @20,2 SAY "Evaluacin curso: " GET eval_curso PICTURE "99.99"           
            ENDIF
            READ
            IF LASTKEY()=27          
               limpiamenu(1,1,22,79)   
               RETURN
            ELSE
               resp=dialogo("Evaluacin correcta? S/N ")
               IF resp="S"
                  SEEK clave_trab + clave_cur
                  REPLACE calif_trab WITH eval_curso             
               ENDIF
            ENDIF
         ENDDO
      ENDIF
      limpiamenu(1,1,22,79)
   ENDIF      
   CLOSE p_curso
   CLOSE trabcurs
ENDDO






*************************************************************************
** FUNCION QUE DESPLIEGA LOS CURSOS DEL TRABAJADOR
*************************************************************************
FUNCTION desp_curtra(y1,x1,y2,x2,clave_trab)

DECLARE campos[4]
PRIVATE clave
*SELECT trabcurs
SET COLOR TO W+/BG+,B+/W
campos[1]="cve_curso"
campos[2]="catprin->nom_obj"
campos[3]="p_curso->fecha_ini"
campos[4]="p_curso->fecha_fin"
marcmenu(y1-1,x1-1,y2+1,x2+1,"W+/BG+","B+/W")
GO TOP
DBEDIT(y1,x1,y2,x2,campos,"FUN_ED3",;
 {"XXXXXXXX","XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX","99/99/99","99/99/99"},;
 {"CLAVE","NOMBRE CURSO","FEC. INI.","FEC. FIN"},"","  ","","")
SET COLOR TO W+/BG+,B+/W
IF (LASTKEY()=13)
   clave=&campo_sel
ENDIF
SET FILTER TO
RETURN(clave)

